#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <array>
using namespace std;


int main() {
  ios::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);

  int n, m, k, imp = 0, refuse = 0;
  cin >> n >> m >> k;

  vector <array <int, 2> > angar;
  for (int i = 0; i < n; i++) angar.push_back({0, 0});

  vector <array <int, 3> > q;
  for (int i = 0; i < k; i++) {
    int a, b, c;
    cin >> a >> b >> c;
    q.push_back({a, b, c});
    if (c == 1) q.push_back({a+m, b, 0});
  }
  sort(q.begin(), q.end());

  for (int i = 0; i < q.size(); i++) {
    if (q[i][2] == -1) {
      int d1 = 0;
      if (n > 0) d1 = angar[n-1][0]*24 + angar[n-1][1];
      int d2 = q[i][0]*24 + q[i][1];
      if (d1 == 0 || d1 > d2) imp++;
      else {
        angar[n-1] = {0, 0};
        sort(angar.begin(), angar.end());
      }
    }
    else if (q[i][2] == 0) {
      int ans = -1;
      for (int j = 0; j < n; j++) {
        if (angar[j][0] == q[i][0]-m && angar[j][1] == q[i][1]) ans = j;
      }
      if (ans != -1 && imp > 0) {
        imp--;
        angar[ans] = {0, 0};
        sort(angar.begin(), angar.end());
      }
    }
    else {
      if (n > 0 && angar[0][0] == 0 && angar[0][1] == 0) {
        angar[0] = {q[i][0], q[i][1]};
        sort(angar.begin(), angar.end());
      }
      else refuse++;
    }
  }
  cout << refuse << "\n" << imp;
  return 0;
}
