#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

#define int ll
using ll = long long;


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

//    int n;
//    cin >> n;
    int MAXN = 1'000'000;
    vector<bool> siege(MAXN + 3, false);
    for (int j = 2; j <= MAXN; ++j){
        if (!siege[j]){
            if (j * 1ll * j > MAXN) break;
            for (ll k = j * j; k <= MAXN; k += j){
                siege[k] = true;
            }
        }
    }

    int a, b;
    cin >> a >> b;

    int ans = 1'000'000'000;
    int ind = -1;
    for (int i = a + a % 2; i <= b - b % 2; i += 2){
        int fir = 0;
        for (int d = 2; d <= i / 2; ++d){
            if (!siege[d] && !siege[i - d]){
                fir += 1;
            }
        }
        if (fir % 5 == 0){
            if (ans * 3 < fir) break;
            if (fir < ans){
                ind = i;
                ans = fir;
            }
        }
    }
    if (ind == -1){
        cout << "Impossible";
    } else {
        cout << ind << " " << ans << "\n";
    }
}
