#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

//#define int long long

using namespace std;

inline void cleanup(vector<int>& ships, multiset<int>& dop, int m) {
  for (auto it = dop.begin(); it != dop.end();) {
    int mini = 1e9, in = 0;
    for (int i = 0; i < ships.size(); ++i) {
      if (ships[i] + m <= *it && ships[i] <= mini) {
        mini = ships[i];
        in = i;
      }
    }
    if (mini == 1e9) return;
    auto it2 = it;
    ships[in] = -1;
    ++it;
    dop.erase(it2);
  }
}

void solve() {
  int n, m, k;
  cin >> n >> m >> k;

  multiset<pair<int, int>> scan;
  multiset<int> dop;
  vector<int> ship(n, -1);
  m *= 24;
  while (k--) {
    int d, h, c;
    cin >> d >> h >> c;
    d = d*24 + h;
    scan.insert({d, c});
  }

  int dis = 0;
  for (auto p : scan) {
    if (p.second == -1) {
      int mini = 1e9, in = 0;
      for (int i = 0; i < n; ++i) {
        if (ship[i] + m <= p.first && ship[i] < mini) {
          mini = ship[i];
          in = i;
        }
      }
      if (mini == 1e9) {
        dop.insert(p.first);
      } else {
        ship[in] = -1;
      }
    } else {
      bool f = false;
      cleanup(ship, dop, m);
      for (int i = 0; i < n; ++i) {
        if (ship[i] == -1) {
          ship[i] = p.first;
          f = true;
          break;
        }
      }
      if (!f) ++dis;
    }
  }

  cout << dis << '\n' << dop.size();
}

signed main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  int t = 1;
//  cin >> t;

  while (t--) {
    solve();
  }
}
