#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

#define int long long

using namespace std;

void solve() {
  int n, m;
  cin >> n >> m;
  double mid = 0;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    mid += a[i];
  }

  mid /= n;
  map<int, int> cnt;
  for (int i = 0; i < n; ++i) {
    if (a[i] > m && a[i] < mid) {
      cnt[a[i]]++;
    }
  }

  int ans = 0;
  for (auto p : cnt) {
    if (cnt[ans] < p.second) {
      ans = p.first;
    } else if (cnt[ans] == p.second && p.first > ans) {
      ans = p.first;
    }
  }

  cout << ans;
}

signed main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  int t = 1;
//  cin >> t;
  while (t--) {
    solve();
  }
}
