#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

//#define int long long

using namespace std;

void solve() {
  int n;
  cin >> n;

  unordered_map<int, int> points;
  vector<pair<pair<int, int>, int>> and_btn;
  vector<pair<int, int>> no_btn;

  int k, t;
  for (int i = 0; i < n; ++i) {
    int c;
    cin >> c;
    if (c == 0) {
      int m, s;
      cin >> m >> s;
      points[m] = s;
    } else if (c == 1) {
      int x, y;
      cin >> x >> y;
      no_btn.push_back({x, y});
    } else if (c == 2) {
      int x, y, z;
      cin >> x >> y >> z;
      and_btn.push_back({{x, y}, z});
    } else {
      cin >> k >> t;
    }
  }

  for (int i = 0; i < t; ++i) {
    unordered_map<int, int> n_points;
    for (auto &p : no_btn) {
      n_points[p.second] = max(int(!points[p.first]), n_points[p.second]);
    }
    for (auto &p : and_btn) {
      n_points[p.second] = max(n_points[p.second], int(points[p.first.first] && points[p.first.second]));
    }
    for (auto p : points) {
      if (n_points.find(p.first) == n_points.end()) {
        n_points[p.first] = p.second;
      }
    }
    points.swap(n_points);
    cout << points[k] << '\n';
  }
}

signed main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  int t = 1;
//  cin >> t;

  while (t--) {
    solve();
  }
}
