#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define all(a) a.begin(), a.end()

const int N = 1e6 + 5;
const int INF = 1e18;

inline void solve() {
    vector<int> p(N, 0);
    for (int i = 2; i <= N; ++i) {
        if (!p[i]) p[i] = 1;
        for (int j = i + i; j <= N; j += i) {
            p[j] = 2;
        }
    }
    vector<int> primes;
    for (int i = 2; i <= 1e6; ++i) {
        if (p[i] == 1) {
            primes.emplace_back(i);
        }
    }
    vector<int> g(N, 0);
    int a, b;
    cin >> a >> b;
    int mn = INF;
    for (int i = 0; i < primes.size(); ++i) {
        for (int j = i; j < primes.size(); ++j) {
            if (primes[i] + primes[j] < a || (primes[i] + primes[j]) % 2) continue;
            if (primes[i] + primes[j] <= b) {
                g[primes[i] + primes[j]]++;
            } else {
                break;
            }
        }
    }
    int x = 0;
    for (int i = a; i <= b; ++i) {
        if (i % 2) continue;
        if (g[i] % 5 == 0 && g[i] < mn) {
            mn = g[i];
            x = i;
        }
    }
    if (mn == INF) {
        cout << "Impossible\n";
        return;
    }
    cout << x << ' ' << mn << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tests = 1;
    while (tests--) {
        solve();
    }
    return 0;
}