#include <iostream>
#include <set>
#include <vector>
#include <iomanip>
#include <map>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;

//#pragma GCC optimize("unroll-loops,inline,02,03,Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,mmx,abm,fma,popcnt,lzcnt,bmi,bmi2")

void solve() {

    ll n = 0, m = 0, k = 0, rd = 0, cnt1 = 0, cnt2 = 0;
    cin >> n >> m >> k;
    multiset<pair<pair<ll, ll>, ll>> tl;

    for (int i = 0; i < k; i++) {
        ll x = 0, y = 0, z = 0;
        cin >> x >> y >> z;
        tl.insert({{x, y}, z});
    }

    for (auto pr : tl) {
        ll d = pr.first.first;
        ll c = pr.first.second;
        ll p = pr.second;

        if (p == 1) {
            if (n == 0) {
                cnt1++;
            }
            else {
                n--;
                tl.insert({{d + m, c}, -2});
            }
        }
        if (p == -2) {
            rd++;
            if (cnt2 > 0) {
                cnt2--;
                n++;
                rd--;
            }
        }
        if (p == -1) {
            if (rd > 0) {
                rd--;
                n++;
            }
            else {
                cnt2++;
            }
        }
    }
    cout << cnt1 << "\n" << cnt2;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
