#include <iostream>
#include <set>
#include <vector>
#include <iomanip>
#include <map>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;

//#pragma GCC optimize("unroll-loops,inline,02,03,Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,mmx,abm,fma,popcnt,lzcnt,bmi,bmi2")

const ll INF = 1e18 + 9;

void solve() {

    ll n = 0, m = 0, ans = 0, ans1 = INF;
    cin >> n >> m;

    vector<int> res(m + 1, 1);
    vector<ll> p;
    unordered_map<ll, ll> mp;

    res[0] = 0;
    res[1] = 0;
    for (int i = 2; i <= sqrt(m) + 1; i++) {
        for (int j = i * i; j <= m; j += i) {
            res[j] = 0;
        }
    }
    for (int i = 2; i <= m; i++) {
        if (res[i]) {
            p.push_back(i);
        }
    }

    if (n % 2 == 1) {
        n++;
    }
    for (int i = n; i <= m; i += 2) {
        ll cnt = 0;
        for (int j = 0; j < p.size() && p[j] <= i / 2; j++) {
            if (res[i - p[j]]) {
                cnt++;
            }
        }
        if (cnt == 5) {
            ans = cnt;
            ans1 = i;
            break;
        }
        else if (cnt % 5 == 0 && cnt < ans) {
            ans1 = i;
            ans = cnt;
        }
    }
    if (ans1 == INF) {
        cout << "Impossible";
        return;
    }
    cout << ans1 << " " << ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
