#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <array>
using namespace std;

const int sz = 1e6+1;

bool is_prime(int x) {
  int del = 2;
  while (x >= del*del) {
    if (x % del == 0) return false;
    del++;
  }
  return true;
}

int main() {
  ios::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);
  int a, b;
  cin >> a >> b;
  vector <array <int, 2> > num;
  for (int i = a; i <= b; i++) {
    if (i%2 == 0) num.push_back({i, 0});
  }
  vector <int> p;
  for (int i = 2; i < sz; i++) {
    if (is_prime(i)) {
      p.push_back(i);
    }
  }
  for (int i = 0; i < num.size(); i++) {
    int x = 0;
    while (x < p.size() && p[x] <= num[i][0]/2) {
      int L = 0, R = 78498;
      while (R-L > 1) {
        int M = (R+L)/2;
        if (p[M] <= num[i][0]-p[x]) L = M;
        else R = M;
      }
      if (p[L] == num[i][0]-p[x]) {
        num[i][1]++;
      }
      x++;
    }
    if (num[i][1]%5 == 0) {
      cout << num[i][0] << ' ' << num[i][1];
      return 0;
    }
  }
  cout << "Impossible";
  return 0;
}

