#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <array>
using namespace std;

const int sz = 1e6+1;

int main() {
  ios::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);
  int n, m, sum = 0;
  cin >> n >> m;
  vector <int> field(n);
  for (int i = 0; i < n; i++) {
    cin >> field[i];
    sum += field[i];
  }
  if (sum%n > 0) sum = sum/n+1;
  else sum /= n;
  vector <array <int, 2> > best;
  for (int i = 0; i < n; i++) {
    if (field[i] > m && field[i] < sum) {
      int L = 0, R = best.size();
      while (R-L > 1) {
        int M = (R+L)/2;
        if (best[M][1] <= field[i]) L = M;
        else R = M;
      }
      if (best.size() == 0 || best[L][1] != field[i]) best.push_back({1, field[i]});
      else if (best[L][1] == field[i]) best[L][0]++;
    }
  }
  if (best.size() == 0) {
    cout << 0;
    return 0;
  }
  sort(best.begin(), best.end());
  cout << best[best.size()-1][1];
  return 0;
}

