#include <iostream>
#include <vector>
#include <array>
#include <algorithm>
#include <fstream>
using namespace std;

int main() {
  string name;
  cin >> name;
  fopen("input.txt", "r");
  ifstream fin("input.txt");

  int n;
  fin >> n;
  vector <array <int, 4> > command(n);
  for (int i = 0; i < n; i++) {
    fin >> command[i][0] >> command[i][1] >> command[i][2];
    if (command[i][0] == 2) fin >> command[i][3];
  }
  sort(command.begin(), command.end());

  int k = command[n-1][1], t = command[n-1][2], cnt = 0;
  for (int i = 0; i < n; i++) if (command[i][0] == 0) cnt++;

  vector <vector <int> > a(t+1, vector <int> (cnt+1, -1));
  for (int i = 1; i <= cnt; i++) a[0][command[i-1][1]] = command[i-1][2];
  for (int i = 1; i <= t; i++) {
    for (int j = cnt; j < n; j++) {
      int ans = 0;
      if (command[j][0] == 1) {
        int ans = (a[i-1][command[j][1]] == 0 ? 1 : 0);
        if (a[i][command[j][2]] == -1) a[i][command[j][2]] = ans;
        else a[i][command[j][2]] = min(a[i][command[j][2]] + ans, 1);
      }
      else if (command[j][0] == 2) {
        int ans = a[i-1][command[j][1]] * a[i-1][command[j][2]];
        if (a[i][command[j][3]] == -1) a[i][command[j][3]] = ans;
        else a[i][command[j][3]] = min(a[i][command[j][3]] + ans, 1);
      }
    }
    for (int j = 1; j <= cnt; j++) if (a[i][j] == -1) a[i][j] = a[i-1][j];
    cout << a[i][k] << "\n";
  }
  fclose(0);
  return 0;
}
