#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
#define int ll

bool is_prime(int n) {
    for (int j = 2; j * j <= n; ++j) {
        if (n % j == 0) return false;
    }
    return true;
}

ll binpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n == 1) {
        return a;
    }
    if (n % 2 == 0) {
        ll fir = binpow(a, n / 2);
        return fir * fir;
    }
    return a * binpow(a, n - 1);
}

deque<int> from_des_to_other(int p, ll num) {
    ll num2 = num;
    deque<int> lst;
    while (num2 > 0) {
        lst.push_front(num2 % p);
        num2 /= p;
    }
    return lst;
}

ll from_other_to_des(int p, deque<int> lst) {
    ll num = 0;
    int helper = lst.size() - 1;
    for (int i = 0; i < lst.size(); i++) {
        int ind = i + helper;
        helper -= 2;
        num = num + binpow(p, ind) * lst[i];
    }
    return num;
}


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll x;
        cin >> x;
        deque<int> lst = from_des_to_other(13, x);
        for (auto u : lst) {
            if (u % 6 == 0){
                ans++;
            }
        }
    }
    cout << ans;
}