﻿#include <iostream>
#include <vector>
#include <numeric>
#include <string.h>
#include <fstream>
#include <queue>
#include <map>

using namespace std;
using ll = long long;

int main() {
	int n, m;
	cin >> n >> m;

	vector<ll> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	ll sum = 0;
	for (ll x : a) {
		sum += x;
	}

	map<ll, int> cnt;
	for (int i = 0; i < n; ++i) {
		if (a[i] * n < sum && a[i] > m) {
			cnt[a[i]]++;
		}
	}

	ll ans = 0;
	for (auto p : cnt) {
		if (p.second >= cnt[ans]) {
			ans = max(ans, p.first);
		}
	}

	cout << ans;
}