#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define int int64_t
using namespace std;

struct rebre {
    int t, x, y, z = -1;
};

bool cmp(rebre& a, rebre& b) {
    if (a.t == b.t) {
        return a.x < b.x;
    }
    return a.t < b.t;
}

int32_t main() {
    int n;
    cin >> n;
    vector<rebre> a(n);
    for (auto& e : a) {
        cin >> e.t >> e.x >> e.y;
        if (e.t == 2) {
            cin >> e.z;
        }
    }
    sort(a.begin(), a.end(), cmp);
    map<int, bool> t;
    for (int i = 0; a[i].t == 0; ++i) {
        t[a[i].x] = a[i].y;
    }
    int k = a.back().x;
    int tt = a.back().y;
    a.pop_back();
    reverse(a.begin(), a.end());
    while (a.back().t == 0) {
        a.pop_back();
    }
    map<int, bool> buf;
    map<int, bool> kek;
    for (int i = 0; i < tt; ++i) {
        buf.clear();
        kek.clear();
        for (auto e : a) {
            if (e.t == 1) {
                kek[e.y] = true;
                buf[e.y] |= !t[e.x];
            } else {
                kek[e.z] = true;
                buf[e.z] |= t[e.x] && t[e.y];
            }
        }
        for (auto e : buf) {
            if (kek[e.first]) {
                t[e.first] = e.second;
                kek[e.first] = false;
            }
        }
        cout << t[k] << '\n';
    }
    return 0;
}
