#include <iostream>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>

//#define int long long

using namespace std;

bitset<1000001> prime;
vector<int> nums;

int g(int x) {
  int cnt = 0;
  for (int& num : nums) {
    if (num >= x) break;
    if (x - num < num) break;
    cnt += prime[x - num];
    if (x - num <= num) break;
  }
  return cnt;
}

void solve() {
  int a, b;
  cin >> a >> b;
  a += a&1;
  int ans = 1e9, ansi = 0;
  for (int i = a; i <= b; i += 2) {
    int gg = g(i);
    if (gg % 5 == 0 && gg < ans) {
      ans = gg;
      ansi = i;
    }
  }
  if (ans == 1e9) {
    cout << "Impossible";
  } else {
    cout << ansi << ' ' << ans;
  }
}

signed main() {
  std::ios::sync_with_stdio(false);
  std::cin.tie(nullptr);
  std::cout.tie(nullptr);

  int t = 1;
//  cin >> t;

  for (int i = 2; i <= prime.size(); ++i) {
    if (prime[i]) continue;
    for (int j = 2*i; j < prime.size(); j += i) {
      prime[j] = 1;
    }
  }

  nums.reserve(80000);
  for (int i = 2; i < prime.size(); ++i) {
    prime[i] = !prime[i];
    if (prime[i]) nums.push_back(i);
  }

  while (t--) {
    solve();
  }
}
