#include <iostream>
#include <set>
#include <vector>
#include <iomanip>
#include <map>
#include <queue>
#include <deque>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;

//#pragma GCC optimize("unroll-loops,inline,02,03,Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,mmx,abm,fma,popcnt,lzcnt,bmi,bmi2")

const ll INF = 1e18 + 9;

void solve() {

    ll n = 0;
    cin >> n;

    unordered_map<ll, ll> cur, nxt;
    vector<pair<pair<ll, ll>, ll>> nd;
    vector<pair<ll, ll>> nt;

    for (int i = 0; i < n; i++) {
        ll x = 0, y = 0, z = 0;
        cin >> x >> y >> z;
        if (x == 0) {
            cur[y] = z;
        }
        if (x == 1) {
            nt.push_back({y, z});
        }
        if (x == 2) {
            ll w = 0;
            cin >> w;
            nd.push_back({{y, z}, w});
        }
        if (x == 3) {
            ll k = y;
            ll t = z;

            for (int j = 0; j < t; j++) {

                for (pair<ll, ll> p : cur) {
                    nxt[p.first] = p.second;
                }

                for (int l = 0; l < nd.size(); l++) {
                    ll out = nd[l].second;
                    ll in1 = nd[l].first.first;
                    ll in2 = nd[l].first.second;

                    nxt[out] = cur[in1] && cur[in2];
                }

                for (int l = 0; l < nt.size(); l++) {
                    ll out = nt[l].second;
                    ll in = nt[l].first;

                    nxt[out] = !cur[in];
                }

                unordered_map<ll, ll> ncur;
                cur = ncur;
                for (pair<ll, ll> p : nxt) {
                    cur[p.first] = p.second;
                }

                cout << cur[k] << "\n";

                unordered_map<ll, ll> nnxt;
                nxt = nnxt;
            }
        }
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
